package nlib.cmm.fileupload;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import egovframework.com.cmm.EgovWebUtil;
import egovframework.com.cmm.service.FileVO;
import nlib.cmm.exception.ErrorMessage;
import nlib.cmm.service.NlibProperty;
import nlib.util.FileUtil;
import nlib.util.StringUtil;
import nlib.util.UUID;

/**
 * <pre>
 * @Class Name : FileUploadController.java
 * 
 * @Description : 파일 업로드를 처리하는 컨트롤러  
 * 
 * 
 * @프로젝트명: 지방문화원 통합자료관리시스템 구축사업 (2021)
 *
 * </pre>
 *
 * @ ------------    --------    ---------------------------
 * @ 수정일                     수정자             수정내용
 * @ ------------    --------    ---------------------------
 * @ 2021. 7. 15.    KNKIM       최초 생성
 *
 * 
 * @author 이씨플라자 * DIGITALSHIP KNKIM
 * @since 2021. 7. 15.
 * @version 1.0
 *
 */
@Controller
public class FileUploadController {

	private static final Logger log = LoggerFactory.getLogger(FileUploadController.class);

	@Resource(name="nlibProperty")
	NlibProperty nlibProperty;
	
	
	/**
	 * 첨부파일이 저장되는 최상위 위치 
	 */
	private String FILEUPLOAD_BASE_PATH = nlibProperty.getProperty("fileupload.base.path");
	
	/**
	 * 첨부파일 임시 저장 위치 
	 */
	private String FILEUPLOAD_TEMP_SUBPATH = nlibProperty.getProperty("fileupload.temp.subpath");

	/**
	 * 경로 부적합 오류 메시지 
	 */
	private static final String MSG_NOT_VALID_FILE_PATH = "파일 경로가 부적합합니다. 관리자에게 문의하여 주시기 바랍니다."; 

	
	/**
	 * 파일업로드(Ajax) 처리
	 * - 화면 : Javascript Free Open Framework DropZone 사용 
	 * 
	 * @param multiRequest
	 * @param subPathKey
	 * @param response : 파일정보를 담은 JSON String  
	 * @return
	 */
	@ResponseBody
	@RequestMapping(value="/fileupload/uploadFilesAjax.do", produces="application/json")
	public ResponseEntity uploadFilesAjax(
			final MultipartHttpServletRequest multiRequest
			, @RequestParam("subPathKey") String subPathKey
			, HttpServletResponse response) {
		
		String message = null;
		
		// TODO : 권한 체크 추가할 것 
		List<FileVO> result = new ArrayList<FileVO>();
		
		try {

			// 최상위 위치 
			if(FileUtil.isEmpty(FILEUPLOAD_BASE_PATH)) {
				message = "첨부파일이 저장되는 최상위 위치정보값이 정확하지 않습니다.";
				log.error(message + " : FILEUPLOAD_BASE_PATH 값 부재");
				ErrorMessage errorMessage = new ErrorMessage("ERROR", message);
				return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
			}
			
			// 서브 위치 
			if(StringUtil.isEmpty(subPathKey)) {
				message = "첨부파일이 저장되는 하위 위치정보값이 정확하지 않습니다.";
				log.error(message + " : 매개변수 subPathKey 값 부재");
				ErrorMessage errorMessage = new ErrorMessage("ERROR", message);
				return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
			}
			String subPath = nlibProperty.getProperty(subPathKey);
			if(StringUtil.isEmpty(subPath)) {
				message = "첨부파일이 저장되는 하위 위치정보값을 찾을 수 없습니다.";
				log.error(message + " : 매개변수 subPathKey의 속성값 부재");
				ErrorMessage errorMessage = new ErrorMessage("ERROR", message);
				return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
			}
			
			// 위치정보 적합 확인 
			if(FileUtil.isNotValid(FILEUPLOAD_BASE_PATH + subPath)) {
				message = MSG_NOT_VALID_FILE_PATH;
				log.error(message + " : " + (FILEUPLOAD_BASE_PATH + subPath));
				ErrorMessage errorMessage = new ErrorMessage("ERROR", message);
				return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
			}
			
			// 파일 업로드 처리 
			final Map<String, MultipartFile> files = multiRequest.getFileMap();
			log.debug("uploadFilesAjax : 진입 > 파일수 = " + (files == null ? " files null " : files.size()));
			
			File dir = new File(FILEUPLOAD_BASE_PATH + subPath);
			if(!dir.exists() || !dir.isDirectory()) dir.mkdirs();
			
			if(!files.isEmpty()) {
				
				Iterator<Entry<String, MultipartFile>> itr = files.entrySet().iterator();
				MultipartFile file;
				String filePath = "";
				FileVO fvo;
				
				int fileKey = 1;
				while (itr.hasNext()) {
					Entry<String, MultipartFile> entry = itr.next();

					file = entry.getValue();
					String orginFileName = file.getOriginalFilename();

					//--------------------------------------
					// 원 파일명이 없는 경우 처리 SKIP 
					// (첨부가 되지 않은 input file type)
					//--------------------------------------
					if (orginFileName == null || "".equals(orginFileName)) {
						continue;
					}

					int index = orginFileName.lastIndexOf(".");
					String fileExt = (index < 1 ? "" : orginFileName.substring(index + 1));
					String newName = UUID.getPhysicalFileName();
					long size = file.getSize();
					
					if (!"".equals(orginFileName)) {
						filePath = FILEUPLOAD_BASE_PATH + subPath + "/" + newName;
						log.debug("FILE UPLOAD : filePath=" + filePath);
						
						file.transferTo(new File(FileUtil.filePathBlackList(filePath)));
					}
					
					fvo = new FileVO();
					fvo.setFileExtsn(fileExt);
					fvo.setFileMg(Long.toString(size));
					fvo.setOrignlFileNm(orginFileName);
					fvo.setStreFileNm(newName);
					fvo.setFileSn(String.valueOf(fileKey));

					result.add(fvo);

					fileKey++;
				}
			}
		} catch(Exception e) {
			ErrorMessage errorMessage = new ErrorMessage("ERROR", "처리에 실패하였습니다 : " + e.toString());
			e.printStackTrace();
			return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
		}
		
		// Convert Json
		ObjectMapper mapper = new ObjectMapper();
		String json;
		try {
			json = mapper.writeValueAsString(result);
			log.debug("RETURN DATA > json:" + json);
		} catch (JsonProcessingException e) {
			json = null;
			e.printStackTrace();
			ErrorMessage errorMessage = new ErrorMessage("ERROR", "JSON 변환 처리에 실패하였습니다 : " + e.toString());
			return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(errorMessage);
		}

		HttpHeaders responseHeaders = new HttpHeaders();
	    ResponseEntity ret = ResponseEntity.ok().headers(responseHeaders).body(json);
		return ret;
	}
	
	/**
	 * 파일 다운로드를 처리한다. 
	 * 
	 * @param params
	 * @param mv
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(value="/fileupload/downloadFiles.do")
	public ModelAndView download(@RequestParam HashMap<Object, Object> params, ModelAndView mv) throws Exception {
		
		// TODO 권한 설정 기능 추가 필요 
		
		String fid = (String) params.get("fid");
		String fname = (String) params.get("fname");
		String subPath = nlibProperty.getProperty((String) params.get("subPathKey"));
		
		String fullPath = FILEUPLOAD_BASE_PATH + "/" + subPath + "/" + fid;
		if(FileUtil.isNotValid(fullPath)) {
			throw new Exception(MSG_NOT_VALID_FILE_PATH);
		}
		
		File file = new File(FileUtil.filePathBlackList(fullPath));
		if(!file.isFile()) {
			throw new Exception("파일 정보가 부적합합니다. 관리자에게 문의하여 주시기 바랍니다.");
		}
		
		mv.setViewName("downloadView"); // dispatcher-servlet.xml내 BeanNameViewResolver 정의 
		mv.addObject("downloadFile", file);
		mv.addObject("fname", fname);
		
		return mv;
	}
}

